#include <bits/stdc++.h>

using namespace std;

#define GLIBCXX_DEBUG

using str = string;
using ll = long long;

const ll INF = 2e18;
const int N = 1e9;

vector<bool> ans, p;
vector<vector<int>> g;

void bfs(int s, int h) {
    deque<int> d;
    p[s] = true, ans[s] = true;
    d.push_back(s);
    int cnt = 0;
    int p_v = s;
    while (!d.empty()) {
        bool p_u = false;
//        cnt++;  не здесь
        int v = d.front();
        if (p_v == v) {
            cnt++;
        }
        if (cnt > h) {
            break;
        }
        for (auto u: g[v]) {
            if (!p[u]) {
                p[u] = true, ans[u] = true;
                d.push_back(u);
                if (!p_u) {
                    p_u = true;
                    p_v = u;
                }
            }
        }
        d.pop_front();
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    ans.resize(n, false), p.resize(n, false);
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    while (k--) {
        int s, h;
        cin >> s >> h;
        s--;
        bfs(s, h);
    }
    int ans_c = 0;
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            ans_c++;
        }
    }
    cout << ans_c << '\n';
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << i + 1 << ' ';
        }
    }
}
